#include <iostream>
#include <fstream>
#include <cstring>
#include <cctype>

using namespace std;

int main() 
{
    setlocale(LC_ALL, "Russian");

    //  1:     
    char filename[256];
    cout << "  : ";
    cin.getline(filename, sizeof(filename));

    //  2:    
    bool isValid = true;

    //    
    const char* forbiddenChars = "*\"<>?|";
    if (strpbrk(filename, forbiddenChars) != nullptr)
        isValid = false;

    //   
    if (strchr(filename, ':') != nullptr && 
        (filename[1] != '\\' || !isalpha(filename[0]) || 
        strchr(filename, '\\') != strrchr(filename, '\\')))
        isValid = false;

    //  3:   
    const char* extension = ".txt";
    if (strncmp(strrchr(filename, '.'), extension, strlen(extension)) != 0)
        strcat(filename, extension);

    //  4:      
    if (isValid) 
    {
        ifstream file(filename, ios::binary | ios::ate);
        if (file.is_open()) 
        {
            streampos fileSize = file.tellg();
            char* buffer = new char[fileSize];
            file.seekg(0, ios::beg);
            file.read(buffer, fileSize);
            file.close();

            //  5:    
            char searchString[256];
            cout << "   : ";
            cin.getline(searchString, sizeof(searchString));

            //  6:       
            int count = 0;
            char* p = buffer;
            while ((p = strstr(p, searchString)) != nullptr) 
            {
                count++;
                p += strlen(searchString);
            }

            cout << "   \"" << searchString << "\"   : " << count << endl;

            //  7:   
            delete[] buffer;
        }
        else 
            cout << "  ." << endl;
    }
    else 
        cout << "  ." << endl;

    system("pause");
    return 0;
}